//
//  Modelo.swift
//  Music-Mate-New-Design
//
//  Created by LTMD on 23/08/2018.
//  Copyright © 2018 LT Music Developer. All rights reserved.
//

import Foundation

struct EngineNota {
    var filtro = 0
    var inicio = 0
    var fim = 0
    
    mutating func set(filtro: Int = 0, inicio: Int = 0, fim: Int = 0) {
        self.filtro = filtro
        self.inicio = inicio
        self.fim = fim
    }
}

class Pico {
    var index: Int
    var filtro: Int
    var energia: Float
    
    var estaVazio: Bool { get { return filtro == 0 && energia == 0 } }
    
    init(index: Int = 0, filtro: Int = 0, energia: Float = 0) {
        self.index = index
        self.filtro = filtro
        self.energia = energia
    }
    
    func toString() -> String {
        var s = "index: \(index) \t"
        s += "filtro: \(filtro) \t"
        s += "energia: \(energia) \n"
        
        return s
    }
    
    func copy () -> Pico {
        return Pico(index: self.index, filtro: self.filtro, energia: self.energia)
    }
}


struct ConfiguracaoCompasso {
    var compasso = 0
    var notaBase = 960
    var metronomo = 90
    var tempoCompasso = TempoCompasso(numerador: 4, denominador: 4)
}

struct TempoCompasso {
    var numerador: Int
    var denominador: Int
    
    var razao: Float { get {return Float(numerador)/Float(denominador)} }
}
