//
//  Complex.swift
//  Engine
//
//  Created by Diego Lopes on 4/4/18.
//  Copyright © 2018 Diego Developer. All rights reserved.
//

import UIKit

class Complexo {
    /**
     * Calcula a multiplicacao entre dois numeros complexos.
     *
     * @param realNum1 a parte real do primeiro numero.
     * @param imagNum1 a parte imaginaria do primeiro numero.
     * @param realNum2 a parte real do segundo numero.
     * @param imagNum2 a parte imaginaria do segundo numero.
     *
     * @return o resultado da multiplicacao.
     */
    func multiplicar(realNum1: Float, imagNum1: Float, realNum2: Float, imagNum2: Float) -> (Float, Float) {
        let real = realNum1 * realNum2 - imagNum1 * imagNum2
        let imag = realNum1 * imagNum2 + imagNum1 * realNum2
        return (real, imag)
    }
    
    /**
     * Calcula a magnitude de um numero complexo.
     *
     * @param real a parte real do numero.
     * @param imag a parte imaginaria do numero.
     *
     * @return a magnitude.
     */
    func magnitude(real: Float, imag: Float) -> Float {
        return sqrt(powf(real, 2) + powf(imag, 2))
    }
}
