import Flutter
import UIKit

public class SwiftMsDspPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "ms_dsp", binaryMessenger: registrar.messenger())
    let instance = SwiftMsDspPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    if(call.method.elementsEqual("process")){
        let args = call.arguments as? NSDictionary

        let audio = (args!["data"]! as! Array<NSNumber>).map { $0.floatValue }
        let index = args!["index"] as! Int
        let engineNote = (args!["engineNote"]! as! Array<NSNumber>).map { $0.intValue }

        let comparador = CompararSimples()

        let resposta = comparador.analisar(audio: audio, index: index, engineNote: engineNote)

        result(resposta)
    } else {
        result("not")
    }
  }
}
