
import 'dart:async';
import 'dart:typed_data';

import 'package:flutter/services.dart';

class MsDsp {
  static const MethodChannel _channel = MethodChannel('ms_dsp');

  static Future<String?> get platformVersion async {
    final String? version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<List<double>> process(List<double> data, int index, List<int> engineNote) async {
    Map<String, dynamic> args = <String, dynamic>{};
    args.putIfAbsent('data', () => data);
    args.putIfAbsent('index', () => index);
    args.putIfAbsent('engineNote', () => index);

    return (await _channel.invokeMethod('process', args) as List).map((e) => e as double).toList();
  }
}
